//+------------------------------------------------------------------+
//|                                           MACD_his_Brout_V00.mq4 |
//|                               Copyright 2024,02, Mehrdad Sarrafi |
//|                                     https://www.te.com/m_sarrafi |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024,02, Mehrdad Sarrafi"
#property link      "https://www.te.com/m_sarrafi"
#property version   "1.00"
#property strict
#property indicator_chart_window

#property indicator_buffers 3
#property indicator_plots   2
//--- plot
#property indicator_label1 "Buy"
#property indicator_label2  "Sell"

//extern   int      BarsToProcess=200;         // Bar to process
//0 or negative value to process all data

int            bar_count_Brout=30;
int            cz_ext_max=7;

//--- indicator buffers
double         MacdBuffer[],BufferBuy[],BufferSell[];

bool cr_up=false,cr_dwn=false;
bool search_Br_up=false,search_Br_dwn=false;
int cr_up_i=0,cr_dwn_i=0;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class his_ext
  {
public:
   double            value;
   int               index;
   bool              valid;
                     his_ext(void) {value=0 ; index=0; valid=false;};
                    ~his_ext(void) {};
  } ext_down,ext_up;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,BufferBuy,INDICATOR_DATA);
   SetIndexBuffer(1,BufferSell,INDICATOR_DATA);
   SetIndexBuffer(2,MacdBuffer,INDICATOR_CALCULATIONS);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,4,clrGreen);//Blue ,clrLightBlue,
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,4,clrRed);//clrPink

   SetIndexArrow(0,221);// ,200
   SetIndexArrow(1,222);// ,202

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);

   IndicatorSetString(INDICATOR_SHORTNAME,"MACD Historam BrOut");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int i,limit;
//---
   limit=rates_total-prev_calculated;
   if(prev_calculated>0)
      limit++;

//--- main loop of calculations
   for(i=0; i<limit; i++)
     {
      MacdBuffer[i]=iMA(NULL,0,12,0,MODE_EMA,PRICE_CLOSE,i)-//InpFastEMA
                    iMA(NULL,0,26,0,MODE_EMA,PRICE_CLOSE,i);//InpSlowEMA
     }
//---
   for(int j=limit-1; j>0; j--)
     {
      //---
      if(search_Br_dwn && ext_down.value!=0 && ext_down.index>j+1)
        {
         if(MacdBuffer[j]<=ext_down.value)
           {
    //       printf("setting Sell"+iTime(NULL,0,j));
               BufferSell[j]=close[j];
            search_Br_dwn=false;
           }
         if(MathAbs(ext_down.index-j)>bar_count_Brout)
           {
            search_Br_dwn=false;
            ext_down.value=0;
            ext_down.index=0;
           }
        }
      if(MacdBuffer[j]>0 && MacdBuffer[j-1]<0)  // cross down
        {
         cr_dwn=true;
         cr_dwn_i=j;
        }

      if(cr_dwn)
        {
         if(MathAbs(cr_dwn_i - j)<=cz_ext_max)
           {
            if(MacdBuffer[j]<=MacdBuffer[j-1])
              {
               ext_down.value=MacdBuffer[j];
               ext_down.index=j;
               cr_dwn=false;
               search_Br_dwn=true;
              }
           }
         else
           {
            ext_down.value=0;
            ext_down.index=0;
            cr_dwn=false;
            search_Br_dwn=false;
           }
        }
      //---
      if(search_Br_up && ext_up.value!=0 && ext_up.index>j+1)
        {
         if(MacdBuffer[j]>=ext_up.value)
           {
    //       printf("setting buy"+iTime(NULL,0,j));
          //      printf(iCustom(NULL,0,"MACD_his_Brout",0,j));
////
             BufferBuy[j]=close[j];
            search_Br_up=false;
           }
         if(MathAbs(ext_up.index-j)>bar_count_Brout)
           {
            search_Br_up=false;
            ext_up.value=0;
            ext_up.index=0;
           }
        }
      if(MacdBuffer[j]<0 && MacdBuffer[j-1]>0)  // cross up
        {
         cr_up= true;
         cr_up_i=j;
        }

      if(cr_up)
        {
         if(MathAbs(cr_up_i - j)<=cz_ext_max)
           {
            if(MacdBuffer[j]>=MacdBuffer[j-1])
              {
               ext_up.value=MacdBuffer[j];
               ext_up.index=j;
               cr_up=false;
               search_Br_up=true;
              }
           }
         else
           {
            ext_up.value=0;
            ext_up.index=0;
            cr_up=false;
            search_Br_up=false;
           }
        }
      //---
     }



//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
